// Code generated by ent, DO NOT EDIT.

package match

import (
	"time"

	"entgo.io/ent/dialect/sql"
	"entgo.io/ent/dialect/sql/sqlgraph"
	"somegit.dev/csgowtf/csgowtfd/ent/predicate"
)

// ID filters vertices based on their ID field.
func ID(id uint64) predicate.Match {
	return predicate.Match(sql.FieldEQ(FieldID, id))
}

// IDEQ applies the EQ predicate on the ID field.
func IDEQ(id uint64) predicate.Match {
	return predicate.Match(sql.FieldEQ(FieldID, id))
}

// IDNEQ applies the NEQ predicate on the ID field.
func IDNEQ(id uint64) predicate.Match {
	return predicate.Match(sql.FieldNEQ(FieldID, id))
}

// IDIn applies the In predicate on the ID field.
func IDIn(ids ...uint64) predicate.Match {
	return predicate.Match(sql.FieldIn(FieldID, ids...))
}

// IDNotIn applies the NotIn predicate on the ID field.
func IDNotIn(ids ...uint64) predicate.Match {
	return predicate.Match(sql.FieldNotIn(FieldID, ids...))
}

// IDGT applies the GT predicate on the ID field.
func IDGT(id uint64) predicate.Match {
	return predicate.Match(sql.FieldGT(FieldID, id))
}

// IDGTE applies the GTE predicate on the ID field.
func IDGTE(id uint64) predicate.Match {
	return predicate.Match(sql.FieldGTE(FieldID, id))
}

// IDLT applies the LT predicate on the ID field.
func IDLT(id uint64) predicate.Match {
	return predicate.Match(sql.FieldLT(FieldID, id))
}

// IDLTE applies the LTE predicate on the ID field.
func IDLTE(id uint64) predicate.Match {
	return predicate.Match(sql.FieldLTE(FieldID, id))
}

// ShareCode applies equality check predicate on the "share_code" field. It's identical to ShareCodeEQ.
func ShareCode(v string) predicate.Match {
	return predicate.Match(sql.FieldEQ(FieldShareCode, v))
}

// Map applies equality check predicate on the "map" field. It's identical to MapEQ.
func Map(v string) predicate.Match {
	return predicate.Match(sql.FieldEQ(FieldMap, v))
}

// Date applies equality check predicate on the "date" field. It's identical to DateEQ.
func Date(v time.Time) predicate.Match {
	return predicate.Match(sql.FieldEQ(FieldDate, v))
}

// ScoreTeamA applies equality check predicate on the "score_team_a" field. It's identical to ScoreTeamAEQ.
func ScoreTeamA(v int) predicate.Match {
	return predicate.Match(sql.FieldEQ(FieldScoreTeamA, v))
}

// ScoreTeamB applies equality check predicate on the "score_team_b" field. It's identical to ScoreTeamBEQ.
func ScoreTeamB(v int) predicate.Match {
	return predicate.Match(sql.FieldEQ(FieldScoreTeamB, v))
}

// ReplayURL applies equality check predicate on the "replay_url" field. It's identical to ReplayURLEQ.
func ReplayURL(v string) predicate.Match {
	return predicate.Match(sql.FieldEQ(FieldReplayURL, v))
}

// Duration applies equality check predicate on the "duration" field. It's identical to DurationEQ.
func Duration(v int) predicate.Match {
	return predicate.Match(sql.FieldEQ(FieldDuration, v))
}

// MatchResult applies equality check predicate on the "match_result" field. It's identical to MatchResultEQ.
func MatchResult(v int) predicate.Match {
	return predicate.Match(sql.FieldEQ(FieldMatchResult, v))
}

// MaxRounds applies equality check predicate on the "max_rounds" field. It's identical to MaxRoundsEQ.
func MaxRounds(v int) predicate.Match {
	return predicate.Match(sql.FieldEQ(FieldMaxRounds, v))
}

// DemoParsed applies equality check predicate on the "demo_parsed" field. It's identical to DemoParsedEQ.
func DemoParsed(v bool) predicate.Match {
	return predicate.Match(sql.FieldEQ(FieldDemoParsed, v))
}

// VacPresent applies equality check predicate on the "vac_present" field. It's identical to VacPresentEQ.
func VacPresent(v bool) predicate.Match {
	return predicate.Match(sql.FieldEQ(FieldVacPresent, v))
}

// GamebanPresent applies equality check predicate on the "gameban_present" field. It's identical to GamebanPresentEQ.
func GamebanPresent(v bool) predicate.Match {
	return predicate.Match(sql.FieldEQ(FieldGamebanPresent, v))
}

// DecryptionKey applies equality check predicate on the "decryption_key" field. It's identical to DecryptionKeyEQ.
func DecryptionKey(v []byte) predicate.Match {
	return predicate.Match(sql.FieldEQ(FieldDecryptionKey, v))
}

// TickRate applies equality check predicate on the "tick_rate" field. It's identical to TickRateEQ.
func TickRate(v float64) predicate.Match {
	return predicate.Match(sql.FieldEQ(FieldTickRate, v))
}

// ShareCodeEQ applies the EQ predicate on the "share_code" field.
func ShareCodeEQ(v string) predicate.Match {
	return predicate.Match(sql.FieldEQ(FieldShareCode, v))
}

// ShareCodeNEQ applies the NEQ predicate on the "share_code" field.
func ShareCodeNEQ(v string) predicate.Match {
	return predicate.Match(sql.FieldNEQ(FieldShareCode, v))
}

// ShareCodeIn applies the In predicate on the "share_code" field.
func ShareCodeIn(vs ...string) predicate.Match {
	return predicate.Match(sql.FieldIn(FieldShareCode, vs...))
}

// ShareCodeNotIn applies the NotIn predicate on the "share_code" field.
func ShareCodeNotIn(vs ...string) predicate.Match {
	return predicate.Match(sql.FieldNotIn(FieldShareCode, vs...))
}

// ShareCodeGT applies the GT predicate on the "share_code" field.
func ShareCodeGT(v string) predicate.Match {
	return predicate.Match(sql.FieldGT(FieldShareCode, v))
}

// ShareCodeGTE applies the GTE predicate on the "share_code" field.
func ShareCodeGTE(v string) predicate.Match {
	return predicate.Match(sql.FieldGTE(FieldShareCode, v))
}

// ShareCodeLT applies the LT predicate on the "share_code" field.
func ShareCodeLT(v string) predicate.Match {
	return predicate.Match(sql.FieldLT(FieldShareCode, v))
}

// ShareCodeLTE applies the LTE predicate on the "share_code" field.
func ShareCodeLTE(v string) predicate.Match {
	return predicate.Match(sql.FieldLTE(FieldShareCode, v))
}

// ShareCodeContains applies the Contains predicate on the "share_code" field.
func ShareCodeContains(v string) predicate.Match {
	return predicate.Match(sql.FieldContains(FieldShareCode, v))
}

// ShareCodeHasPrefix applies the HasPrefix predicate on the "share_code" field.
func ShareCodeHasPrefix(v string) predicate.Match {
	return predicate.Match(sql.FieldHasPrefix(FieldShareCode, v))
}

// ShareCodeHasSuffix applies the HasSuffix predicate on the "share_code" field.
func ShareCodeHasSuffix(v string) predicate.Match {
	return predicate.Match(sql.FieldHasSuffix(FieldShareCode, v))
}

// ShareCodeEqualFold applies the EqualFold predicate on the "share_code" field.
func ShareCodeEqualFold(v string) predicate.Match {
	return predicate.Match(sql.FieldEqualFold(FieldShareCode, v))
}

// ShareCodeContainsFold applies the ContainsFold predicate on the "share_code" field.
func ShareCodeContainsFold(v string) predicate.Match {
	return predicate.Match(sql.FieldContainsFold(FieldShareCode, v))
}

// MapEQ applies the EQ predicate on the "map" field.
func MapEQ(v string) predicate.Match {
	return predicate.Match(sql.FieldEQ(FieldMap, v))
}

// MapNEQ applies the NEQ predicate on the "map" field.
func MapNEQ(v string) predicate.Match {
	return predicate.Match(sql.FieldNEQ(FieldMap, v))
}

// MapIn applies the In predicate on the "map" field.
func MapIn(vs ...string) predicate.Match {
	return predicate.Match(sql.FieldIn(FieldMap, vs...))
}

// MapNotIn applies the NotIn predicate on the "map" field.
func MapNotIn(vs ...string) predicate.Match {
	return predicate.Match(sql.FieldNotIn(FieldMap, vs...))
}

// MapGT applies the GT predicate on the "map" field.
func MapGT(v string) predicate.Match {
	return predicate.Match(sql.FieldGT(FieldMap, v))
}

// MapGTE applies the GTE predicate on the "map" field.
func MapGTE(v string) predicate.Match {
	return predicate.Match(sql.FieldGTE(FieldMap, v))
}

// MapLT applies the LT predicate on the "map" field.
func MapLT(v string) predicate.Match {
	return predicate.Match(sql.FieldLT(FieldMap, v))
}

// MapLTE applies the LTE predicate on the "map" field.
func MapLTE(v string) predicate.Match {
	return predicate.Match(sql.FieldLTE(FieldMap, v))
}

// MapContains applies the Contains predicate on the "map" field.
func MapContains(v string) predicate.Match {
	return predicate.Match(sql.FieldContains(FieldMap, v))
}

// MapHasPrefix applies the HasPrefix predicate on the "map" field.
func MapHasPrefix(v string) predicate.Match {
	return predicate.Match(sql.FieldHasPrefix(FieldMap, v))
}

// MapHasSuffix applies the HasSuffix predicate on the "map" field.
func MapHasSuffix(v string) predicate.Match {
	return predicate.Match(sql.FieldHasSuffix(FieldMap, v))
}

// MapIsNil applies the IsNil predicate on the "map" field.
func MapIsNil() predicate.Match {
	return predicate.Match(sql.FieldIsNull(FieldMap))
}

// MapNotNil applies the NotNil predicate on the "map" field.
func MapNotNil() predicate.Match {
	return predicate.Match(sql.FieldNotNull(FieldMap))
}

// MapEqualFold applies the EqualFold predicate on the "map" field.
func MapEqualFold(v string) predicate.Match {
	return predicate.Match(sql.FieldEqualFold(FieldMap, v))
}

// MapContainsFold applies the ContainsFold predicate on the "map" field.
func MapContainsFold(v string) predicate.Match {
	return predicate.Match(sql.FieldContainsFold(FieldMap, v))
}

// DateEQ applies the EQ predicate on the "date" field.
func DateEQ(v time.Time) predicate.Match {
	return predicate.Match(sql.FieldEQ(FieldDate, v))
}

// DateNEQ applies the NEQ predicate on the "date" field.
func DateNEQ(v time.Time) predicate.Match {
	return predicate.Match(sql.FieldNEQ(FieldDate, v))
}

// DateIn applies the In predicate on the "date" field.
func DateIn(vs ...time.Time) predicate.Match {
	return predicate.Match(sql.FieldIn(FieldDate, vs...))
}

// DateNotIn applies the NotIn predicate on the "date" field.
func DateNotIn(vs ...time.Time) predicate.Match {
	return predicate.Match(sql.FieldNotIn(FieldDate, vs...))
}

// DateGT applies the GT predicate on the "date" field.
func DateGT(v time.Time) predicate.Match {
	return predicate.Match(sql.FieldGT(FieldDate, v))
}

// DateGTE applies the GTE predicate on the "date" field.
func DateGTE(v time.Time) predicate.Match {
	return predicate.Match(sql.FieldGTE(FieldDate, v))
}

// DateLT applies the LT predicate on the "date" field.
func DateLT(v time.Time) predicate.Match {
	return predicate.Match(sql.FieldLT(FieldDate, v))
}

// DateLTE applies the LTE predicate on the "date" field.
func DateLTE(v time.Time) predicate.Match {
	return predicate.Match(sql.FieldLTE(FieldDate, v))
}

// ScoreTeamAEQ applies the EQ predicate on the "score_team_a" field.
func ScoreTeamAEQ(v int) predicate.Match {
	return predicate.Match(sql.FieldEQ(FieldScoreTeamA, v))
}

// ScoreTeamANEQ applies the NEQ predicate on the "score_team_a" field.
func ScoreTeamANEQ(v int) predicate.Match {
	return predicate.Match(sql.FieldNEQ(FieldScoreTeamA, v))
}

// ScoreTeamAIn applies the In predicate on the "score_team_a" field.
func ScoreTeamAIn(vs ...int) predicate.Match {
	return predicate.Match(sql.FieldIn(FieldScoreTeamA, vs...))
}

// ScoreTeamANotIn applies the NotIn predicate on the "score_team_a" field.
func ScoreTeamANotIn(vs ...int) predicate.Match {
	return predicate.Match(sql.FieldNotIn(FieldScoreTeamA, vs...))
}

// ScoreTeamAGT applies the GT predicate on the "score_team_a" field.
func ScoreTeamAGT(v int) predicate.Match {
	return predicate.Match(sql.FieldGT(FieldScoreTeamA, v))
}

// ScoreTeamAGTE applies the GTE predicate on the "score_team_a" field.
func ScoreTeamAGTE(v int) predicate.Match {
	return predicate.Match(sql.FieldGTE(FieldScoreTeamA, v))
}

// ScoreTeamALT applies the LT predicate on the "score_team_a" field.
func ScoreTeamALT(v int) predicate.Match {
	return predicate.Match(sql.FieldLT(FieldScoreTeamA, v))
}

// ScoreTeamALTE applies the LTE predicate on the "score_team_a" field.
func ScoreTeamALTE(v int) predicate.Match {
	return predicate.Match(sql.FieldLTE(FieldScoreTeamA, v))
}

// ScoreTeamBEQ applies the EQ predicate on the "score_team_b" field.
func ScoreTeamBEQ(v int) predicate.Match {
	return predicate.Match(sql.FieldEQ(FieldScoreTeamB, v))
}

// ScoreTeamBNEQ applies the NEQ predicate on the "score_team_b" field.
func ScoreTeamBNEQ(v int) predicate.Match {
	return predicate.Match(sql.FieldNEQ(FieldScoreTeamB, v))
}

// ScoreTeamBIn applies the In predicate on the "score_team_b" field.
func ScoreTeamBIn(vs ...int) predicate.Match {
	return predicate.Match(sql.FieldIn(FieldScoreTeamB, vs...))
}

// ScoreTeamBNotIn applies the NotIn predicate on the "score_team_b" field.
func ScoreTeamBNotIn(vs ...int) predicate.Match {
	return predicate.Match(sql.FieldNotIn(FieldScoreTeamB, vs...))
}

// ScoreTeamBGT applies the GT predicate on the "score_team_b" field.
func ScoreTeamBGT(v int) predicate.Match {
	return predicate.Match(sql.FieldGT(FieldScoreTeamB, v))
}

// ScoreTeamBGTE applies the GTE predicate on the "score_team_b" field.
func ScoreTeamBGTE(v int) predicate.Match {
	return predicate.Match(sql.FieldGTE(FieldScoreTeamB, v))
}

// ScoreTeamBLT applies the LT predicate on the "score_team_b" field.
func ScoreTeamBLT(v int) predicate.Match {
	return predicate.Match(sql.FieldLT(FieldScoreTeamB, v))
}

// ScoreTeamBLTE applies the LTE predicate on the "score_team_b" field.
func ScoreTeamBLTE(v int) predicate.Match {
	return predicate.Match(sql.FieldLTE(FieldScoreTeamB, v))
}

// ReplayURLEQ applies the EQ predicate on the "replay_url" field.
func ReplayURLEQ(v string) predicate.Match {
	return predicate.Match(sql.FieldEQ(FieldReplayURL, v))
}

// ReplayURLNEQ applies the NEQ predicate on the "replay_url" field.
func ReplayURLNEQ(v string) predicate.Match {
	return predicate.Match(sql.FieldNEQ(FieldReplayURL, v))
}

// ReplayURLIn applies the In predicate on the "replay_url" field.
func ReplayURLIn(vs ...string) predicate.Match {
	return predicate.Match(sql.FieldIn(FieldReplayURL, vs...))
}

// ReplayURLNotIn applies the NotIn predicate on the "replay_url" field.
func ReplayURLNotIn(vs ...string) predicate.Match {
	return predicate.Match(sql.FieldNotIn(FieldReplayURL, vs...))
}

// ReplayURLGT applies the GT predicate on the "replay_url" field.
func ReplayURLGT(v string) predicate.Match {
	return predicate.Match(sql.FieldGT(FieldReplayURL, v))
}

// ReplayURLGTE applies the GTE predicate on the "replay_url" field.
func ReplayURLGTE(v string) predicate.Match {
	return predicate.Match(sql.FieldGTE(FieldReplayURL, v))
}

// ReplayURLLT applies the LT predicate on the "replay_url" field.
func ReplayURLLT(v string) predicate.Match {
	return predicate.Match(sql.FieldLT(FieldReplayURL, v))
}

// ReplayURLLTE applies the LTE predicate on the "replay_url" field.
func ReplayURLLTE(v string) predicate.Match {
	return predicate.Match(sql.FieldLTE(FieldReplayURL, v))
}

// ReplayURLContains applies the Contains predicate on the "replay_url" field.
func ReplayURLContains(v string) predicate.Match {
	return predicate.Match(sql.FieldContains(FieldReplayURL, v))
}

// ReplayURLHasPrefix applies the HasPrefix predicate on the "replay_url" field.
func ReplayURLHasPrefix(v string) predicate.Match {
	return predicate.Match(sql.FieldHasPrefix(FieldReplayURL, v))
}

// ReplayURLHasSuffix applies the HasSuffix predicate on the "replay_url" field.
func ReplayURLHasSuffix(v string) predicate.Match {
	return predicate.Match(sql.FieldHasSuffix(FieldReplayURL, v))
}

// ReplayURLIsNil applies the IsNil predicate on the "replay_url" field.
func ReplayURLIsNil() predicate.Match {
	return predicate.Match(sql.FieldIsNull(FieldReplayURL))
}

// ReplayURLNotNil applies the NotNil predicate on the "replay_url" field.
func ReplayURLNotNil() predicate.Match {
	return predicate.Match(sql.FieldNotNull(FieldReplayURL))
}

// ReplayURLEqualFold applies the EqualFold predicate on the "replay_url" field.
func ReplayURLEqualFold(v string) predicate.Match {
	return predicate.Match(sql.FieldEqualFold(FieldReplayURL, v))
}

// ReplayURLContainsFold applies the ContainsFold predicate on the "replay_url" field.
func ReplayURLContainsFold(v string) predicate.Match {
	return predicate.Match(sql.FieldContainsFold(FieldReplayURL, v))
}

// DurationEQ applies the EQ predicate on the "duration" field.
func DurationEQ(v int) predicate.Match {
	return predicate.Match(sql.FieldEQ(FieldDuration, v))
}

// DurationNEQ applies the NEQ predicate on the "duration" field.
func DurationNEQ(v int) predicate.Match {
	return predicate.Match(sql.FieldNEQ(FieldDuration, v))
}

// DurationIn applies the In predicate on the "duration" field.
func DurationIn(vs ...int) predicate.Match {
	return predicate.Match(sql.FieldIn(FieldDuration, vs...))
}

// DurationNotIn applies the NotIn predicate on the "duration" field.
func DurationNotIn(vs ...int) predicate.Match {
	return predicate.Match(sql.FieldNotIn(FieldDuration, vs...))
}

// DurationGT applies the GT predicate on the "duration" field.
func DurationGT(v int) predicate.Match {
	return predicate.Match(sql.FieldGT(FieldDuration, v))
}

// DurationGTE applies the GTE predicate on the "duration" field.
func DurationGTE(v int) predicate.Match {
	return predicate.Match(sql.FieldGTE(FieldDuration, v))
}

// DurationLT applies the LT predicate on the "duration" field.
func DurationLT(v int) predicate.Match {
	return predicate.Match(sql.FieldLT(FieldDuration, v))
}

// DurationLTE applies the LTE predicate on the "duration" field.
func DurationLTE(v int) predicate.Match {
	return predicate.Match(sql.FieldLTE(FieldDuration, v))
}

// MatchResultEQ applies the EQ predicate on the "match_result" field.
func MatchResultEQ(v int) predicate.Match {
	return predicate.Match(sql.FieldEQ(FieldMatchResult, v))
}

// MatchResultNEQ applies the NEQ predicate on the "match_result" field.
func MatchResultNEQ(v int) predicate.Match {
	return predicate.Match(sql.FieldNEQ(FieldMatchResult, v))
}

// MatchResultIn applies the In predicate on the "match_result" field.
func MatchResultIn(vs ...int) predicate.Match {
	return predicate.Match(sql.FieldIn(FieldMatchResult, vs...))
}

// MatchResultNotIn applies the NotIn predicate on the "match_result" field.
func MatchResultNotIn(vs ...int) predicate.Match {
	return predicate.Match(sql.FieldNotIn(FieldMatchResult, vs...))
}

// MatchResultGT applies the GT predicate on the "match_result" field.
func MatchResultGT(v int) predicate.Match {
	return predicate.Match(sql.FieldGT(FieldMatchResult, v))
}

// MatchResultGTE applies the GTE predicate on the "match_result" field.
func MatchResultGTE(v int) predicate.Match {
	return predicate.Match(sql.FieldGTE(FieldMatchResult, v))
}

// MatchResultLT applies the LT predicate on the "match_result" field.
func MatchResultLT(v int) predicate.Match {
	return predicate.Match(sql.FieldLT(FieldMatchResult, v))
}

// MatchResultLTE applies the LTE predicate on the "match_result" field.
func MatchResultLTE(v int) predicate.Match {
	return predicate.Match(sql.FieldLTE(FieldMatchResult, v))
}

// MaxRoundsEQ applies the EQ predicate on the "max_rounds" field.
func MaxRoundsEQ(v int) predicate.Match {
	return predicate.Match(sql.FieldEQ(FieldMaxRounds, v))
}

// MaxRoundsNEQ applies the NEQ predicate on the "max_rounds" field.
func MaxRoundsNEQ(v int) predicate.Match {
	return predicate.Match(sql.FieldNEQ(FieldMaxRounds, v))
}

// MaxRoundsIn applies the In predicate on the "max_rounds" field.
func MaxRoundsIn(vs ...int) predicate.Match {
	return predicate.Match(sql.FieldIn(FieldMaxRounds, vs...))
}

// MaxRoundsNotIn applies the NotIn predicate on the "max_rounds" field.
func MaxRoundsNotIn(vs ...int) predicate.Match {
	return predicate.Match(sql.FieldNotIn(FieldMaxRounds, vs...))
}

// MaxRoundsGT applies the GT predicate on the "max_rounds" field.
func MaxRoundsGT(v int) predicate.Match {
	return predicate.Match(sql.FieldGT(FieldMaxRounds, v))
}

// MaxRoundsGTE applies the GTE predicate on the "max_rounds" field.
func MaxRoundsGTE(v int) predicate.Match {
	return predicate.Match(sql.FieldGTE(FieldMaxRounds, v))
}

// MaxRoundsLT applies the LT predicate on the "max_rounds" field.
func MaxRoundsLT(v int) predicate.Match {
	return predicate.Match(sql.FieldLT(FieldMaxRounds, v))
}

// MaxRoundsLTE applies the LTE predicate on the "max_rounds" field.
func MaxRoundsLTE(v int) predicate.Match {
	return predicate.Match(sql.FieldLTE(FieldMaxRounds, v))
}

// DemoParsedEQ applies the EQ predicate on the "demo_parsed" field.
func DemoParsedEQ(v bool) predicate.Match {
	return predicate.Match(sql.FieldEQ(FieldDemoParsed, v))
}

// DemoParsedNEQ applies the NEQ predicate on the "demo_parsed" field.
func DemoParsedNEQ(v bool) predicate.Match {
	return predicate.Match(sql.FieldNEQ(FieldDemoParsed, v))
}

// VacPresentEQ applies the EQ predicate on the "vac_present" field.
func VacPresentEQ(v bool) predicate.Match {
	return predicate.Match(sql.FieldEQ(FieldVacPresent, v))
}

// VacPresentNEQ applies the NEQ predicate on the "vac_present" field.
func VacPresentNEQ(v bool) predicate.Match {
	return predicate.Match(sql.FieldNEQ(FieldVacPresent, v))
}

// GamebanPresentEQ applies the EQ predicate on the "gameban_present" field.
func GamebanPresentEQ(v bool) predicate.Match {
	return predicate.Match(sql.FieldEQ(FieldGamebanPresent, v))
}

// GamebanPresentNEQ applies the NEQ predicate on the "gameban_present" field.
func GamebanPresentNEQ(v bool) predicate.Match {
	return predicate.Match(sql.FieldNEQ(FieldGamebanPresent, v))
}

// DecryptionKeyEQ applies the EQ predicate on the "decryption_key" field.
func DecryptionKeyEQ(v []byte) predicate.Match {
	return predicate.Match(sql.FieldEQ(FieldDecryptionKey, v))
}

// DecryptionKeyNEQ applies the NEQ predicate on the "decryption_key" field.
func DecryptionKeyNEQ(v []byte) predicate.Match {
	return predicate.Match(sql.FieldNEQ(FieldDecryptionKey, v))
}

// DecryptionKeyIn applies the In predicate on the "decryption_key" field.
func DecryptionKeyIn(vs ...[]byte) predicate.Match {
	return predicate.Match(sql.FieldIn(FieldDecryptionKey, vs...))
}

// DecryptionKeyNotIn applies the NotIn predicate on the "decryption_key" field.
func DecryptionKeyNotIn(vs ...[]byte) predicate.Match {
	return predicate.Match(sql.FieldNotIn(FieldDecryptionKey, vs...))
}

// DecryptionKeyGT applies the GT predicate on the "decryption_key" field.
func DecryptionKeyGT(v []byte) predicate.Match {
	return predicate.Match(sql.FieldGT(FieldDecryptionKey, v))
}

// DecryptionKeyGTE applies the GTE predicate on the "decryption_key" field.
func DecryptionKeyGTE(v []byte) predicate.Match {
	return predicate.Match(sql.FieldGTE(FieldDecryptionKey, v))
}

// DecryptionKeyLT applies the LT predicate on the "decryption_key" field.
func DecryptionKeyLT(v []byte) predicate.Match {
	return predicate.Match(sql.FieldLT(FieldDecryptionKey, v))
}

// DecryptionKeyLTE applies the LTE predicate on the "decryption_key" field.
func DecryptionKeyLTE(v []byte) predicate.Match {
	return predicate.Match(sql.FieldLTE(FieldDecryptionKey, v))
}

// DecryptionKeyIsNil applies the IsNil predicate on the "decryption_key" field.
func DecryptionKeyIsNil() predicate.Match {
	return predicate.Match(sql.FieldIsNull(FieldDecryptionKey))
}

// DecryptionKeyNotNil applies the NotNil predicate on the "decryption_key" field.
func DecryptionKeyNotNil() predicate.Match {
	return predicate.Match(sql.FieldNotNull(FieldDecryptionKey))
}

// TickRateEQ applies the EQ predicate on the "tick_rate" field.
func TickRateEQ(v float64) predicate.Match {
	return predicate.Match(sql.FieldEQ(FieldTickRate, v))
}

// TickRateNEQ applies the NEQ predicate on the "tick_rate" field.
func TickRateNEQ(v float64) predicate.Match {
	return predicate.Match(sql.FieldNEQ(FieldTickRate, v))
}

// TickRateIn applies the In predicate on the "tick_rate" field.
func TickRateIn(vs ...float64) predicate.Match {
	return predicate.Match(sql.FieldIn(FieldTickRate, vs...))
}

// TickRateNotIn applies the NotIn predicate on the "tick_rate" field.
func TickRateNotIn(vs ...float64) predicate.Match {
	return predicate.Match(sql.FieldNotIn(FieldTickRate, vs...))
}

// TickRateGT applies the GT predicate on the "tick_rate" field.
func TickRateGT(v float64) predicate.Match {
	return predicate.Match(sql.FieldGT(FieldTickRate, v))
}

// TickRateGTE applies the GTE predicate on the "tick_rate" field.
func TickRateGTE(v float64) predicate.Match {
	return predicate.Match(sql.FieldGTE(FieldTickRate, v))
}

// TickRateLT applies the LT predicate on the "tick_rate" field.
func TickRateLT(v float64) predicate.Match {
	return predicate.Match(sql.FieldLT(FieldTickRate, v))
}

// TickRateLTE applies the LTE predicate on the "tick_rate" field.
func TickRateLTE(v float64) predicate.Match {
	return predicate.Match(sql.FieldLTE(FieldTickRate, v))
}

// TickRateIsNil applies the IsNil predicate on the "tick_rate" field.
func TickRateIsNil() predicate.Match {
	return predicate.Match(sql.FieldIsNull(FieldTickRate))
}

// TickRateNotNil applies the NotNil predicate on the "tick_rate" field.
func TickRateNotNil() predicate.Match {
	return predicate.Match(sql.FieldNotNull(FieldTickRate))
}

// HasStats applies the HasEdge predicate on the "stats" edge.
func HasStats() predicate.Match {
	return predicate.Match(func(s *sql.Selector) {
		step := sqlgraph.NewStep(
			sqlgraph.From(Table, FieldID),
			sqlgraph.Edge(sqlgraph.O2M, false, StatsTable, StatsColumn),
		)
		sqlgraph.HasNeighbors(s, step)
	})
}

// HasStatsWith applies the HasEdge predicate on the "stats" edge with a given conditions (other predicates).
func HasStatsWith(preds ...predicate.MatchPlayer) predicate.Match {
	return predicate.Match(func(s *sql.Selector) {
		step := newStatsStep()
		sqlgraph.HasNeighborsWith(s, step, func(s *sql.Selector) {
			for _, p := range preds {
				p(s)
			}
		})
	})
}

// HasPlayers applies the HasEdge predicate on the "players" edge.
func HasPlayers() predicate.Match {
	return predicate.Match(func(s *sql.Selector) {
		step := sqlgraph.NewStep(
			sqlgraph.From(Table, FieldID),
			sqlgraph.Edge(sqlgraph.M2M, true, PlayersTable, PlayersPrimaryKey...),
		)
		sqlgraph.HasNeighbors(s, step)
	})
}

// HasPlayersWith applies the HasEdge predicate on the "players" edge with a given conditions (other predicates).
func HasPlayersWith(preds ...predicate.Player) predicate.Match {
	return predicate.Match(func(s *sql.Selector) {
		step := newPlayersStep()
		sqlgraph.HasNeighborsWith(s, step, func(s *sql.Selector) {
			for _, p := range preds {
				p(s)
			}
		})
	})
}

// And groups predicates with the AND operator between them.
func And(predicates ...predicate.Match) predicate.Match {
	return predicate.Match(func(s *sql.Selector) {
		s1 := s.Clone().SetP(nil)
		for _, p := range predicates {
			p(s1)
		}
		s.Where(s1.P())
	})
}

// Or groups predicates with the OR operator between them.
func Or(predicates ...predicate.Match) predicate.Match {
	return predicate.Match(func(s *sql.Selector) {
		s1 := s.Clone().SetP(nil)
		for i, p := range predicates {
			if i > 0 {
				s1.Or()
			}
			p(s1)
		}
		s.Where(s1.P())
	})
}

// Not applies the not operator on the given predicate.
func Not(p predicate.Match) predicate.Match {
	return predicate.Match(func(s *sql.Selector) {
		p(s.Not())
	})
}
