// Code generated by ent, DO NOT EDIT.

package messages

import (
	"entgo.io/ent/dialect/sql"
	"entgo.io/ent/dialect/sql/sqlgraph"
	"somegit.dev/csgowtf/csgowtfd/ent/predicate"
)

// ID filters vertices based on their ID field.
func ID(id int) predicate.Messages {
	return predicate.Messages(sql.FieldEQ(FieldID, id))
}

// IDEQ applies the EQ predicate on the ID field.
func IDEQ(id int) predicate.Messages {
	return predicate.Messages(sql.FieldEQ(FieldID, id))
}

// IDNEQ applies the NEQ predicate on the ID field.
func IDNEQ(id int) predicate.Messages {
	return predicate.Messages(sql.FieldNEQ(FieldID, id))
}

// IDIn applies the In predicate on the ID field.
func IDIn(ids ...int) predicate.Messages {
	return predicate.Messages(sql.FieldIn(FieldID, ids...))
}

// IDNotIn applies the NotIn predicate on the ID field.
func IDNotIn(ids ...int) predicate.Messages {
	return predicate.Messages(sql.FieldNotIn(FieldID, ids...))
}

// IDGT applies the GT predicate on the ID field.
func IDGT(id int) predicate.Messages {
	return predicate.Messages(sql.FieldGT(FieldID, id))
}

// IDGTE applies the GTE predicate on the ID field.
func IDGTE(id int) predicate.Messages {
	return predicate.Messages(sql.FieldGTE(FieldID, id))
}

// IDLT applies the LT predicate on the ID field.
func IDLT(id int) predicate.Messages {
	return predicate.Messages(sql.FieldLT(FieldID, id))
}

// IDLTE applies the LTE predicate on the ID field.
func IDLTE(id int) predicate.Messages {
	return predicate.Messages(sql.FieldLTE(FieldID, id))
}

// Message applies equality check predicate on the "message" field. It's identical to MessageEQ.
func Message(v string) predicate.Messages {
	return predicate.Messages(sql.FieldEQ(FieldMessage, v))
}

// AllChat applies equality check predicate on the "all_chat" field. It's identical to AllChatEQ.
func AllChat(v bool) predicate.Messages {
	return predicate.Messages(sql.FieldEQ(FieldAllChat, v))
}

// Tick applies equality check predicate on the "tick" field. It's identical to TickEQ.
func Tick(v int) predicate.Messages {
	return predicate.Messages(sql.FieldEQ(FieldTick, v))
}

// MessageEQ applies the EQ predicate on the "message" field.
func MessageEQ(v string) predicate.Messages {
	return predicate.Messages(sql.FieldEQ(FieldMessage, v))
}

// MessageNEQ applies the NEQ predicate on the "message" field.
func MessageNEQ(v string) predicate.Messages {
	return predicate.Messages(sql.FieldNEQ(FieldMessage, v))
}

// MessageIn applies the In predicate on the "message" field.
func MessageIn(vs ...string) predicate.Messages {
	return predicate.Messages(sql.FieldIn(FieldMessage, vs...))
}

// MessageNotIn applies the NotIn predicate on the "message" field.
func MessageNotIn(vs ...string) predicate.Messages {
	return predicate.Messages(sql.FieldNotIn(FieldMessage, vs...))
}

// MessageGT applies the GT predicate on the "message" field.
func MessageGT(v string) predicate.Messages {
	return predicate.Messages(sql.FieldGT(FieldMessage, v))
}

// MessageGTE applies the GTE predicate on the "message" field.
func MessageGTE(v string) predicate.Messages {
	return predicate.Messages(sql.FieldGTE(FieldMessage, v))
}

// MessageLT applies the LT predicate on the "message" field.
func MessageLT(v string) predicate.Messages {
	return predicate.Messages(sql.FieldLT(FieldMessage, v))
}

// MessageLTE applies the LTE predicate on the "message" field.
func MessageLTE(v string) predicate.Messages {
	return predicate.Messages(sql.FieldLTE(FieldMessage, v))
}

// MessageContains applies the Contains predicate on the "message" field.
func MessageContains(v string) predicate.Messages {
	return predicate.Messages(sql.FieldContains(FieldMessage, v))
}

// MessageHasPrefix applies the HasPrefix predicate on the "message" field.
func MessageHasPrefix(v string) predicate.Messages {
	return predicate.Messages(sql.FieldHasPrefix(FieldMessage, v))
}

// MessageHasSuffix applies the HasSuffix predicate on the "message" field.
func MessageHasSuffix(v string) predicate.Messages {
	return predicate.Messages(sql.FieldHasSuffix(FieldMessage, v))
}

// MessageEqualFold applies the EqualFold predicate on the "message" field.
func MessageEqualFold(v string) predicate.Messages {
	return predicate.Messages(sql.FieldEqualFold(FieldMessage, v))
}

// MessageContainsFold applies the ContainsFold predicate on the "message" field.
func MessageContainsFold(v string) predicate.Messages {
	return predicate.Messages(sql.FieldContainsFold(FieldMessage, v))
}

// AllChatEQ applies the EQ predicate on the "all_chat" field.
func AllChatEQ(v bool) predicate.Messages {
	return predicate.Messages(sql.FieldEQ(FieldAllChat, v))
}

// AllChatNEQ applies the NEQ predicate on the "all_chat" field.
func AllChatNEQ(v bool) predicate.Messages {
	return predicate.Messages(sql.FieldNEQ(FieldAllChat, v))
}

// TickEQ applies the EQ predicate on the "tick" field.
func TickEQ(v int) predicate.Messages {
	return predicate.Messages(sql.FieldEQ(FieldTick, v))
}

// TickNEQ applies the NEQ predicate on the "tick" field.
func TickNEQ(v int) predicate.Messages {
	return predicate.Messages(sql.FieldNEQ(FieldTick, v))
}

// TickIn applies the In predicate on the "tick" field.
func TickIn(vs ...int) predicate.Messages {
	return predicate.Messages(sql.FieldIn(FieldTick, vs...))
}

// TickNotIn applies the NotIn predicate on the "tick" field.
func TickNotIn(vs ...int) predicate.Messages {
	return predicate.Messages(sql.FieldNotIn(FieldTick, vs...))
}

// TickGT applies the GT predicate on the "tick" field.
func TickGT(v int) predicate.Messages {
	return predicate.Messages(sql.FieldGT(FieldTick, v))
}

// TickGTE applies the GTE predicate on the "tick" field.
func TickGTE(v int) predicate.Messages {
	return predicate.Messages(sql.FieldGTE(FieldTick, v))
}

// TickLT applies the LT predicate on the "tick" field.
func TickLT(v int) predicate.Messages {
	return predicate.Messages(sql.FieldLT(FieldTick, v))
}

// TickLTE applies the LTE predicate on the "tick" field.
func TickLTE(v int) predicate.Messages {
	return predicate.Messages(sql.FieldLTE(FieldTick, v))
}

// HasMatchPlayer applies the HasEdge predicate on the "match_player" edge.
func HasMatchPlayer() predicate.Messages {
	return predicate.Messages(func(s *sql.Selector) {
		step := sqlgraph.NewStep(
			sqlgraph.From(Table, FieldID),
			sqlgraph.Edge(sqlgraph.M2O, true, MatchPlayerTable, MatchPlayerColumn),
		)
		sqlgraph.HasNeighbors(s, step)
	})
}

// HasMatchPlayerWith applies the HasEdge predicate on the "match_player" edge with a given conditions (other predicates).
func HasMatchPlayerWith(preds ...predicate.MatchPlayer) predicate.Messages {
	return predicate.Messages(func(s *sql.Selector) {
		step := newMatchPlayerStep()
		sqlgraph.HasNeighborsWith(s, step, func(s *sql.Selector) {
			for _, p := range preds {
				p(s)
			}
		})
	})
}

// And groups predicates with the AND operator between them.
func And(predicates ...predicate.Messages) predicate.Messages {
	return predicate.Messages(func(s *sql.Selector) {
		s1 := s.Clone().SetP(nil)
		for _, p := range predicates {
			p(s1)
		}
		s.Where(s1.P())
	})
}

// Or groups predicates with the OR operator between them.
func Or(predicates ...predicate.Messages) predicate.Messages {
	return predicate.Messages(func(s *sql.Selector) {
		s1 := s.Clone().SetP(nil)
		for i, p := range predicates {
			if i > 0 {
				s1.Or()
			}
			p(s1)
		}
		s.Where(s1.P())
	})
}

// Not applies the not operator on the given predicate.
func Not(p predicate.Messages) predicate.Messages {
	return predicate.Messages(func(s *sql.Selector) {
		p(s.Not())
	})
}
